/***********************/
/* (c) 2007 dci@cpp.in */
/***********************/

#ifndef _IS_BUFFER_HPP_
#define _IS_BUFFER_HPP_

/* class proto */
class is_buffer
{
private:
	size_t dmax;
	size_t dlen;
	void * data;

public:
	is_buffer   ();
	~is_buffer  ();
	
	void   add  ( size_t len );
	size_t addb ( size_t len, void * ibytes );
	size_t addc ( size_t len, is_buffer * ibuffer );
	void   rem  ( size_t len );
	size_t remb ( size_t len, void * obytes );
	size_t remc ( size_t len, is_buffer * obuffer );

	size_t len  ();
	
	
	size_t         read_data      ( int offset, void * buf, size_t len );
	size_t         write_data     ( int offset, void * buf, size_t len );

	unsigned char  read_byte      ( int offset );
	size_t         write_byte     ( int offset, unsigned char byte );

	unsigned short read_le_word   ( int offset );
	unsigned long  read_le_dword  ( int offset );
	size_t         write_le_word  ( int offset, unsigned short word );
	size_t         write_le_dword ( int offset, unsigned long dword );
	unsigned short read_be_word   ( int offset );
	unsigned long  read_be_dword  ( int offset );
	size_t         write_be_word  ( int offset, unsigned short word );
	size_t         write_be_dword ( int offset, unsigned long dword );
};

#endif
