/***********************/
/* (c) 2007 dci@cpp.in */
/***********************/

#include "is.hpp"
#include "is-common.hpp"
#include "is-clist.hpp"

void is_clist::addg ( unsigned short gid, char * name )
{
	int z;
	this->groups = ( is_cl_group * ) xrealloc ( this->groups, ( this->gnum + 1 ) * sizeof ( is_cl_group ) );
	this->groups[this->gnum].gid = gid;
	z = utf16len ( name );
	this->groups[this->gnum].name = ( char * ) xmalloc ( ( z + 1 ) * 2 );
	memcpy ( this->groups[this->gnum].name, name, ( z + 1 ) * 2 );
	this->gnum++;
}

void is_clist::addi ( unsigned short gid, unsigned short iid, bool awaiting_auth, unsigned short status, char * name, char * nick )
{
	int z;
	this->items = ( is_cl_item * ) xrealloc ( this->items, ( this->inum + 1 ) * sizeof ( is_cl_item ) );
	this->items[this->inum].gid = gid;
	this->items[this->inum].iid = iid;
	this->items[this->inum].awaiting_auth = awaiting_auth;
	this->items[this->inum].status = status;
	z = utf16len ( name );
	this->items[this->inum].name = ( char * ) xmalloc ( ( z + 1 ) * 2 );
	memcpy ( this->items[this->inum].name, name, ( z + 1 ) * 2 );
	z = utf16len ( nick );
	this->items[this->inum].nick = ( char * ) xmalloc ( ( z + 1 ) * 2 );
	memcpy ( this->items[this->inum].nick, nick, ( z + 1 ) * 2 );
	this->inum++;
}

void is_clist::clear ( )
{
	int i;
	for ( i = 0; i < this->gnum; i++ )
	{
		xfree ( this->groups[i].name );
	}
	this->gnum   = 0;
	this->groups = ( is_cl_group * ) xrealloc ( this->groups, 0 );
	for ( int i = 0; i < this->inum; i++ )
	{
		xfree ( this->items[i].name );
		xfree ( this->items[i].nick );
	}
	this->inum  = 0;
	this->items = ( is_cl_item * ) xrealloc ( this->items, 0 );
}

void is_clist::dump ( is_buffer * out )
{
	int i;
	/* GROUPS */
	out->add ( sizeof ( unsigned short ) );
	out->write_le_word ( - sizeof ( unsigned short ), this->gnum - 1 );
	for ( i = 0; i < this->gnum; i++ )
	{
		/* group id */
		out->add ( sizeof ( unsigned short ) );
		out->write_le_word ( - sizeof ( unsigned short ), this->groups[i].gid );
		/* items count */
		int j, cnt = 0;
		for ( int j = 0; j < this->inum; j++ )
		{
			if ( this->items[j].gid == this->groups[i].gid )
			{
				cnt++;
			}
		}
		out->add ( sizeof ( unsigned short ) );
		out->write_le_word ( - sizeof ( unsigned short ), ( unsigned short ) cnt );
		/* name len */
		int nblen = utf16len ( this->groups[i].name ) * 2;
		out->add ( sizeof ( unsigned short ) );
		out->write_le_word ( - sizeof ( unsigned short ), nblen );
		/* name */
		out->addb ( nblen, this->groups[i].name );
	}
	/* ITEMS */
	out->add ( sizeof ( unsigned short ) );
	out->write_le_word ( - sizeof ( unsigned short ), this->inum - 1 );
	for ( i = 0; i < this->inum; i++ )
	{
		int z;
		/* name len */
		z = utf16len ( this->items[i].name ) * 2;
		out->add ( sizeof ( unsigned short ) );
		out->write_le_word ( - sizeof ( unsigned short ), z );
		/* name */
		out->addb ( z, this->items[i].name );
		/* 2 null bytes */
		out->add ( 2 * sizeof ( unsigned char ) );
		/* nick len */
		z = utf16len ( this->items[i].nick ) * 2;
		out->add ( sizeof ( unsigned short ) );
		out->write_le_word ( - sizeof ( unsigned short ), z );
		/* nick */
		out->addb ( z, this->items[i].nick );
		/* awaiting_authorization */
		out->add ( sizeof ( unsigned char ) );
		out->write_byte ( - sizeof ( unsigned char ), this->items[i].awaiting_auth );
		/* status */
		out->add ( sizeof ( unsigned short ) );
		out->write_le_word ( - sizeof ( unsigned short ), this->items[i].status );
		/* group id */
		out->add ( sizeof ( unsigned short ) );
		out->write_le_word ( - sizeof ( unsigned short ), this->items[i].gid );
		/* item id */
		out->add ( sizeof ( unsigned short ) );
		out->write_le_word ( - sizeof ( unsigned short ), this->items[i].iid );
	}
}

is_clist::is_clist ( )
{
	this->gnum   = 0;
	this->groups = ( is_cl_group * ) xmalloc ( 0 );
	this->inum   = 0;
	this->items  = ( is_cl_item * ) xmalloc ( 0 );
}

is_clist::~is_clist ( )
{
	this->clear ( );
	xfree ( this->groups );
	xfree ( this->items );
}
