/***********************/
/* (c) 2007 dci@cpp.in */
/***********************/

#include "is.hpp"
#include "is-common.hpp"
#include "is-proc.hpp"

#include "is-proto-icq.hpp"
#include "is-proto-yahoo.hpp"
#include "is-proto-msn.hpp"
#include "is-proto-mrim.hpp"

/* proto list */
is_proto_t * is_protos[] = { &proto_icq, &proto_yahoo, &proto_msn, &proto_mrim, NULL };

void is_proc::proc_do ( )
{
	int olen = 0;
	while ( ( this->buf_in->len ( ) > 0 ) && ( this->buf_in->len ( ) != olen ) )
	{
		olen = this->buf_in->len ();
		/* parse head */
		if ( this->is_state == IS_STATE_LOGIN )
		{
			unsigned char packet_type = this->buf_in->read_byte ( 0 );
			/* login packet received? */
			if ( packet_type == 0x01 )
			{
				char * tptrb, * tptre;
				/* copy data to temp */
				char * tmpbuf = ( char * ) xmalloc ( this->buf_in->len ( ) + 1);
				this->buf_in->read_data ( 0, tmpbuf, this->buf_in->len ( ) );
				tmpbuf[this->buf_in->len ( )] = 0;
				/* read packet */
				tptrb = tmpbuf + 1;
				/* devid */
				if ( tptre = strstr ( tptrb, "\r\n" ) )
				{
					* tptre = 0;
					xfree ( this->is_device_id );
					this->is_device_id = strdup ( tptrb );
					tptrb = tptre + 2;
					/* proto */
					if ( tptre = strstr ( tptrb, "\r\n" ) )
					{
						* tptre = 0;
						xfree ( this->is_proto );
						this->is_proto = strdup ( tptrb );
						tptrb = tptre + 2;
						/* login */
						if ( tptre = strstr ( tptrb, "\r\n" ) )
						{
							* tptre = 0;
							xfree ( this->is_login );
							this->is_login = strdup ( tptrb );
							/* analyze login */
							if ( ( strlen ( this->is_login ) > 64 ) || strchr ( this->is_login, '/' ) || strchr ( this->is_login, '\\' ) )
							{
								/* set state to error */
								this->is_state = IS_STATE_ERROR;
							}
						}
						else
						{
							/* shit is coming */
							if ( this->buf_in->len ( ) > 192 ) 
							{
								/* set state to error */
								this->is_state = IS_STATE_ERROR;
							}
						}
					}
					else
					{
						/* shit is coming */
						if ( this->buf_in->len ( ) > 96 ) 
						{
							/* set state to error */
							this->is_state = IS_STATE_ERROR;
						}
					}
				}
				else
				{
					/* shit is coming */
					if ( this->buf_in->len ( ) > 64 ) 
					{
						/* set state to error */
						this->is_state = IS_STATE_ERROR;
					}
				}
				
				/* no error? */
				if ( this->is_state == IS_STATE_LOGIN )
				{
					/* discard login data in queue */
					this->buf_in->rem ( ( tptre + 4 ) - tmpbuf );
					/* lookup suitable proto */
					is_proto_t ** t = is_protos;
					while ( * t )
					{
						if ( 0 == strcasecmp ( this->is_proto, ( * t )->name ) )
						{
							this->proto_impl = * t;
							break;
						}
						t++;
					}
					/* found? */
					if ( this->proto_impl )
					{
						/* do proto login */
						this->proto_impl->on_login ( this );
						/* set state to normal */
						this->is_state = IS_STATE_NORMAL;
						/* notify user */
						vlog ( "[%08X] Login: '%s'->'%s': ok", this->sk_fd, this->is_proto, this->is_login );
					}
					else
					{	
						/* discard all data */
						this->buf_in->rem ( this->buf_in->len ( ) );
						/* set state to error */
						this->is_state = IS_STATE_ERROR;
						/* notify user */
						vlog ( "[%08X] Login: '%s'->'%s': proto not found", this->sk_fd, this->is_proto, this->is_login );
					}
				}
				else /* error while reading */
				{
					/* discard all data */
					this->buf_in->rem ( this->buf_in->len ( ) );
					/* set state to error */
					this->is_state = IS_STATE_ERROR;
					/* notify user */
					vlog ( "[%08X] Login: Junk data from client", this->sk_fd );
				}
				/* free temp */
				xfree ( tmpbuf );
			}
			else /* not login packet */
			{
				/* discard all data */
				this->buf_in->rem ( this->buf_in->len ( ) );
				/* set state to error */
				this->is_state = IS_STATE_ERROR;
				/* notify user */
				vlog ( "[%08X] Login: not login packet", this->sk_fd );
			}
		}
		else if ( this->is_state == IS_STATE_NORMAL )
		{	
			unsigned char packet_type = this->buf_in->read_byte ( 0 );
			/* raw packet? */
			if ( ( packet_type == 0x02 ) || ( packet_type == 0x03 ) )
			{
				/* do proto raw */
				this->proto_impl->on_raw ( this );
			}
			else if ( packet_type = 0x04 ) /* filestart */
			{
				/* offered size */
				int dlen = this->buf_in->read_le_dword ( sizeof ( unsigned char ) );
				/* sane size? */
				if ( dlen < 1024 )
				{
					/* received completely? */
					if ( this->buf_in->len ( ) >= dlen )
					{
						/* create directory path for current login */
						char * dirpath = ( char * ) xmalloc ( 5 + 1 + strlen ( this->is_login ) + 1 );
						sprintf ( dirpath, "files/%s", this->is_login );
						/* is it exists? */
						struct stat mstat;
						if ( stat ( dirpath, &mstat ) != 0 )
						{
							/* try to create */
							mkdir ( dirpath, S_IRUSR | S_IWUSR | S_IXUSR );
						}
						xfree ( dirpath );
						/* read file name from packet */
						char * tdata = ( char * ) xmalloc ( dlen );
						this->buf_in->read_data ( 5, tdata, dlen );
						char * filename = utf16_to_ascii ( tdata, dlen );
						
						/* analyze file name */
						if ( ( strlen ( filename ) < 64 ) && ( ( strchr ( filename, '/' ) || strchr ( filename, '\\' ) ) == 0 ) )
						{
							/* create path */
							char * filepath = ( char * ) xmalloc ( 5 + 1 + strlen ( this->is_login ) + 1 + strlen ( filename ) + 1 );
							sprintf ( filepath, "files/%s/%s", this->is_login, filename );
							/* try to open file */
							this->proc_file = fopen ( filepath, "wb" );
							/* */
							xfree ( filepath );
							/* set state to FILE */
							this->is_state = IS_STATE_FILE;
							/* send block_ok notification */
							this->buf_out->add ( sizeof ( unsigned char ) );
							this->buf_out->write_byte ( - sizeof ( unsigned char ), /* file */ 4 );
							this->buf_out->add ( sizeof ( unsigned long ) );
							this->buf_out->write_le_dword ( - sizeof ( unsigned long ), sizeof ( unsigned long ) );
							this->buf_out->add ( sizeof ( unsigned long ) );
							this->buf_out->write_le_dword ( - sizeof ( unsigned long ), dlen );
						}
						else
						{
							/* set state to error */
							this->is_state = IS_STATE_ERROR;
							/* notify user */
							vlog ( "[%08X] File: invalid filename", this->sk_fd );
						}
						/* discard data */
						this->buf_in->rem ( dlen + sizeof ( unsigned char ) + sizeof ( unsigned long ) );
						/* */
						xfree ( filename );
						xfree ( tdata );
					}
				}
				else
				{
					/* discard all data */
					this->buf_in->rem ( this->buf_in->len ( ) );
					/* set state to error */
					this->is_state = IS_STATE_ERROR;
					/* notify user */
					vlog ( "[%08X] File: Junk data from client", this->sk_fd );
				}
				
			}
		}
		else if ( this->is_state == IS_STATE_FILE ) /* filedata/fileend */
		{
			unsigned long blocklen = this->buf_in->read_le_dword ( 0 );
			/* sane size? */
			if ( blocklen < 1048576 )
			{
				/* is block complete? */
				if ( ( blocklen + 4 ) <= this->buf_in->len ( ) )
				{
					/* still in ranks? */
					if ( ( this->proc_file == NULL ) || ( ftell ( this->proc_file ) + blocklen <= MAX_FILE ) )
					{
						if ( blocklen > 0 ) /* filedata */
						{
							/* write data to file */
							if ( this->proc_file )
							{
								void * tdata = xmalloc ( blocklen );
								this->buf_in->read_data ( sizeof ( unsigned long ), tdata, blocklen );
								fwrite ( tdata, 1, blocklen, this->proc_file );
								xfree ( tdata );
							}
							/* send block_ok notification */
							this->buf_out->add ( sizeof ( unsigned char ) );
							this->buf_out->write_byte ( - sizeof ( unsigned char ), /* file */ 4 );
							this->buf_out->add ( sizeof ( unsigned long ) );
							this->buf_out->write_le_dword ( - sizeof ( unsigned long ), sizeof ( unsigned long ) );
							this->buf_out->add ( sizeof ( unsigned long ) );
							this->buf_out->write_le_dword ( - sizeof ( unsigned long ), blocklen );
						}
						else /* fileend */
						{
							/* close file */
							if ( this->proc_file )
							{
								fclose ( this->proc_file );
								this->proc_file = NULL;
							}
							/* set state to NORMAL */
							this->is_state = IS_STATE_NORMAL;
							/* send status notification */
							this->buf_out->add ( sizeof ( unsigned char ) );
							this->buf_out->write_byte ( - sizeof ( unsigned char ), /* file */ 4 );
							this->buf_out->add ( sizeof ( unsigned long ) );
							this->buf_out->write_le_dword ( - sizeof ( unsigned long ), 2 * sizeof ( unsigned long ) );
							this->buf_out->add ( sizeof ( unsigned long ) );
							this->buf_out->write_le_dword ( - sizeof ( unsigned long ), 0 );
							this->buf_out->add ( sizeof ( unsigned long ) );
							this->buf_out->write_le_dword ( - sizeof ( unsigned long ), MAX_FILE );
						}
						/* discard data */
						this->buf_in->rem ( sizeof ( unsigned long ) + blocklen );
					}
					else
					{
						/* discard all data */
						this->buf_in->rem ( this->buf_in->len ( ) );
						/* set state to error */
						this->is_state = IS_STATE_ERROR;
						/* notify user */
						vlog ( "[%08X] File: Too much data from client", this->sk_fd );
					}
				}
			}
			else
			{
				/* discard all data */
				this->buf_in->rem ( this->buf_in->len ( ) );
				/* set state to error */
				this->is_state = IS_STATE_ERROR;
				/* notify user */
				vlog ( "[%08X] File: Junk data from client", this->sk_fd );
			}
		}
		else if ( this->is_state == IS_STATE_ERROR ) /* errors, just clean buffer */
		{
			this->buf_in->rem ( this->buf_in->len ( ) );
		}
	}
}

is_proc::is_proc ( int fd, in_addr rem_addr, unsigned short rem_port )
{
	this->sk_fd = fd;
	this->sk_rem_addr = rem_addr;
	this->sk_rem_port = rem_port;
	this->buf_in  = new is_buffer();
	this->buf_out = new is_buffer();
	this->is_state = IS_STATE_LOGIN;
	this->is_device_id = strdup ( "" );
	this->is_proto = strdup ( "" );
	this->is_login = strdup ( "" );
	this->proto_impl = NULL;
	this->proto_data = NULL;
	this->proc_file = NULL;
	/* notify user */
	vlog ( "[%08X] Connect: %d.%d.%d.%d:%d", this->sk_fd, ( this->sk_rem_addr.s_addr >> 0 ) & 0xFF, ( this->sk_rem_addr.s_addr >> 8 ) & 0xFF, ( this->sk_rem_addr.s_addr >> 16 ) & 0xFF, ( this->sk_rem_addr.s_addr >> 24 ) & 0xFF, ntohs ( this->sk_rem_port ) );
}

is_proc::~is_proc ( )
{
	/* destruct impl */
	if ( this->proto_impl )
	{
		this->proto_impl->on_quit ( this );
	}
	/* close sent file */
	if ( this->proc_file )
	{
		fclose ( this->proc_file );
	}
	/* */
	delete this->buf_in;
	delete this->buf_out;
	xfree ( this->is_device_id );
	xfree ( this->is_proto );
	xfree ( this->is_login );
	/* notify user */
	vlog ( "[%08X] Connect: closed", this->sk_fd );
}
