/***********************/
/* (c) 2007 dci@cpp.in */
/***********************/

#ifndef _IS_PROC_HPP_
#define _IS_PROC_HPP_

#include "is-buffer.hpp"

/* network related includes */
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>


/* pre-protos for crosslinking */
class is_proc;
struct is_proto_t;


/* IS proto impl */
struct is_proto_t
{
	char * name;
	void ( * on_login ) ( is_proc * block );
	void ( * on_raw   ) ( is_proc * block );
	void ( * on_quit  ) ( is_proc * block );
};

/* IS entry states */
#define IS_STATE_LOGIN  0
#define IS_STATE_NORMAL 1
#define IS_STATE_FILE   2

#define IS_STATE_ERROR  (-1)

/* IS entry */
class is_proc
{
public:
	/* socket */
	int          sk_fd;
	in_addr      sk_rem_addr;
	int          sk_rem_port;
	
	/* buffers */
	is_buffer *  buf_in;
	is_buffer *  buf_out;
	
	/* session */
	int          is_state;
	char  *      is_device_id;
	char  *      is_proto;
	char  *      is_login;
	
	/* protocol */
	is_proto_t * proto_impl;
	void       * proto_data; /* pointer for proto to store custom data */
	
	
	/* processor */
	FILE * proc_file;
	void   proc_do ( );
	
	/* expose/dispose */
	is_proc   ( int fd, in_addr rem_addr, unsigned short rem_port );
	~is_proc  ( );
};

#endif
