/***********************/
/* (c) 2007 dci@cpp.in */
/***********************/

#include "is.hpp"

#include "is-proto-msn.hpp"

void msn_login ( is_proc * block )
{
	/* packet type */
	block->buf_out->add ( sizeof ( unsigned char ) );
	block->buf_out->write_byte ( - sizeof ( unsigned char ), /* login */ 1 );
	/* packet len. here this is data len */
	block->buf_out->add ( sizeof ( unsigned long ) );
	block->buf_out->write_le_dword ( -sizeof ( unsigned long ), 2 * sizeof ( unsigned long ) );
	/* maximum file size */
	block->buf_out->add ( sizeof ( unsigned long ) );
	block->buf_out->write_le_dword ( -sizeof ( unsigned long ),  MAX_FILE );
	/* auth */
	block->buf_out->add ( sizeof ( unsigned long ) );
	block->buf_out->write_le_dword ( -sizeof ( unsigned long ),  0x00001f90 );
}

void msn_raw ( is_proc * block )
{
	block->buf_in->rem ( block->buf_in->len ( ) );
	vlog ( "[%08X] MSN proto received RAW data!", block->sk_fd );
}

void msn_quit ( is_proc * block )
{
	block->buf_in->rem ( block->buf_in->len ( ) );
}

is_proto_t proto_msn = { "msn", msn_login, msn_raw, msn_quit };
