/***********************/
/* (c) 2007 dci@cpp.in */
/***********************/

#include "is.hpp"

#include "is-proto-yahoo.hpp"

void yahoo_login ( is_proc * block )
{
	/* packet type */
	block->buf_out->add ( sizeof ( unsigned char ) );
	block->buf_out->write_byte ( - sizeof ( unsigned char ), /* login */ 1 );
	/* packet len. here this is data len */
	block->buf_out->add ( sizeof ( unsigned long ) );
	block->buf_out->write_le_dword ( -sizeof ( unsigned long ), 2 * sizeof ( unsigned long ) );
	/* maximum file size */
	block->buf_out->add ( sizeof ( unsigned long ) );
	block->buf_out->write_le_dword ( -sizeof ( unsigned long ),  MAX_FILE );
	/* auth */
	block->buf_out->add ( sizeof ( unsigned long ) );
	block->buf_out->write_le_dword ( -sizeof ( unsigned long ),  0x00001f90 );
}

void yahoo_raw ( is_proc * block )
{
	block->buf_in->rem ( block->buf_in->len ( ) );
	vlog ( "[%08X] Yahoo proto received RAW data!", block->sk_fd );
}

void yahoo_quit ( is_proc * block )
{
	block->buf_in->rem ( block->buf_in->len ( ) );
}

is_proto_t proto_yahoo = { "yahoo", yahoo_login, yahoo_raw, yahoo_quit };
