/***********************/
/* (c) 2007 dci@cpp.in */
/***********************/

#include "is.hpp"

#include <pwd.h>
#include <grp.h>

FILE * log = NULL;

/* formatted logger */
void vlog ( char * fmt, ...)
{
	va_list ap;
	va_start ( ap, fmt );
	if ( log )
	{
		vfprintf ( log, fmt, ap );
		fprintf ( log, "\n" );
	}
	else
	{
		vprintf ( fmt, ap );
		printf ( "\n" );
	}
	va_end ( ap );
}

/* entry point */
int main ( int argc, char * argv[] )
{
	/* debug. let us coredump on every memory shit */
	_malloc_options = "AZ";


	/* YAW! */
	printf ( "Starting TAIMS 0.0.2d (c) 2006-2007 dci\n" );
	/* params */
	char * lpath = NULL;
	char * iface = NULL;
	char * wroot = NULL;
	char * uname = NULL;
	uid_t  uid   = 0;
	char * gname = NULL;
	gid_t  gid   = 0;
	/* read */
	for ( int cp = 1; cp < argc; cp++ )
	{
		if ( 0 == strcasecmp ( argv[cp], "-l" ) )
		{
			cp++;
			lpath = argv[cp];
		}
		else if ( 0 == strcasecmp ( argv[cp], "-i" ) )
		{
			cp++;
			iface = argv[cp];
		}
		else if ( 0 == strcasecmp ( argv[cp], "-d" ) )
		{
			cp++;
			wroot = argv[cp];
		}
		else if ( 0 == strcasecmp ( argv[cp], "-r" ) )
		{
			cp++;
			uname = argv[cp];
			if ( gname = strchr ( uname, ':' ) )
			{
				* gname = 0;
				gname++;
			}
		}
	}
	/* should work as daemon? */
	if ( lpath )
	{
		log = fopen ( lpath, "a+" );
		if ( log )
		{
			pid_t worker = fork ( );
			if ( worker < 0 )
			{
				vlog ( "fork(): error %d \"%s\"", errno, strerror ( errno ) );
				exit ( 1 );
			}
			else if ( worker > 0 )
			{
				exit ( 0 );
			}
			setsid ( );
		}
		else
		{
			vlog ( "fopen(): error %d \"%s\"", errno, strerror ( errno ) );
			exit ( 1 );
		}
	}
	/* find uid & gid */
	if ( uname )
	{
		passwd * pwd = getpwnam ( uname );
		if ( pwd )
		{
			uid = pwd->pw_uid;
		}
		else
		{
			vlog ( "getpwnam(): error \"user \"%s\" unknown\"", uname );
			exit ( 1 );
		}
	}
	if ( gname )
	{
		group * grp = getgrnam ( gname );
		if ( grp )
		{
			gid = grp->gr_gid;
		}
		else
		{
			vlog ( "getgrnam(): error \"group \"%s\" unknown\"", gname );
			exit ( 1 );
		}
	}
	
	/* run server */
	server ( iface, wroot, uid, gid );
	
	/* finish */
	if ( log )
	{
		fclose ( log );
	}
	return 0;
}
